// C Header File
// Created 7/23/2003; 3:07:01 PM

short display_offset  = 0; // will be set depending on calctype (TI89 or TI92p)
short display_offsetx = 0; // will be set depending on calctype (TI89 or TI92p)
short display_offsety = 0; // will be set depending on calctype (TI89 or TI92p)

#define FIRSTOBJECTCODE 23
#define LASTOBJECTCODE (FIRSTOBJECTCODE+TOTAL_TEXCONFIGS_IN_wolfobj-1)
#define NUMAREAS		37
#define MAXSPRITES 400
#define OPENTICS 40 //Between 3 and 4 seconds (for doors to be open)

#define DOORTEXTURE 49
#define DOORSIDETEXTURE 50
#define DOORKEYTEXTURE 52

#define EXTRAPOINTS		40000

// object flag values

#define FL_SHOOTABLE	1
#define FL_BONUS		2
#define FL_NEVERMARK	4
#define FL_VISABLE		8
#define FL_ATTACKMODE	16
#define FL_FIRSTATTACK	32
#define FL_AMBUSH		64
#define FL_NONMARK		128

#define NUMWEAPONS	5
typedef enum	{
	wp_knife,
	wp_pistol,
	wp_machinegun,
	wp_chaingun
} weapontype;


typedef enum	{
	gd_baby,
	gd_easy,
	gd_medium,
	gd_hard
} difficulties;

#define TILESHIFT
#define TileToArea(a) (-(a)-1)
#define NUMENEMIES		16
typedef enum {
	en_guard,
	en_officer,
	en_ss,
	en_dog,
	en_boss,
	en_schabbs,
	en_fake,
	en_hitler,
	en_mutant,
	en_blinky,
	en_clyde,
	en_pinky,
	en_inky,
	en_gretel,
	en_gift,
	en_fat,
} enemy_t;


typedef struct	statestruct
{
	BOOL	rotate;
	short		shapenum;			// a shapenum of -1 means get from ob->temp1
	short		tictime;
	void	(*think) (),(*action) ();
	struct	statestruct	*next;
} statetype;

typedef enum {
	dr_normal,
	dr_lock1,
	dr_lock2,
	dr_lock3,
	dr_lock4,
	dr_elevator
} door_t;

typedef enum {
	ac_badobject = -1,
	ac_no,
	ac_yes,
	ac_allways
} activetype;

typedef enum {
	nothing,
	playerobj,
	inertobj,
	guardobj,
	officerobj,
	ssobj,
	dogobj,
	bossobj,
	schabbobj,
	fakeobj,
	mechahitlerobj,
	mutantobj,
	needleobj,
	fireobj,
	bjobj,
	ghostobj,
	realhitlerobj,
	gretelobj,
	giftobj,
	fatobj,
	rocketobj,
} classtype;

typedef enum {
	dressing,
	block,
	bo_gibs,
	bo_alpo,
	bo_firstaid,
	bo_key1,
	bo_key2,
	bo_key3,
	bo_key4,
	bo_cross,
	bo_chalice,
	bo_bible,
	bo_crown,
	bo_clip,
	bo_clip2,
	bo_machinegun,
	bo_chaingun,
	bo_food,
	bo_fullheal,
	bo_25clip,
	bo_spear
} stat_t;



unsigned char *objectmap;

short spritecount;
short lightcount;

TEXCONFIG *objects;
FATSPRITE *sprites;
TEXCONFIG *textures;

short ceilmode, floormode;
char *bg_img;

unsigned char *actorat;

unsigned char	pwallstate;
unsigned char	pwallpos;			// amount a pushable wall has been moved (0-63)
unsigned char	pwallx,pwally;
short	pwalldir;
unsigned char oldtile;

unsigned char areaconnect[NUMAREAS][NUMAREAS];
unsigned char	areabyplayer[NUMAREAS];

typedef struct
{
	unsigned char areanumber;
	unsigned char tilex;
	unsigned char tiley;
} Player;
Player *player;

//--------------------
//
// thinking actor structure
//
//------	--------------

typedef struct objstruct
{
//	activetype	active;
	short			ticcount;
	classtype	obclass;
	statetype	*state;

	unsigned char		flags;				//	FL_SHOOTABLE, etc

	long		distance;			// if negative, wait for that door to open
	//dirtype		dir;

//	fixed 		x,y;
	unsigned char	tilex,tiley;
	unsigned char		areanumber;

	short	 		viewx;
	unsigned	viewheight;
//	fixed		transx,transy;		// in global coord

	short 		angle;
	short			hitpoints;
	long		speed;

	short			temp1,temp2,temp3;
	struct		objstruct	*next,*prev;
} objtype;

typedef struct
{
	unsigned char areanumber;
	unsigned char flags;
	unsigned char itemnumber;
	unsigned char drawmode;
} statobj;
statobj *sprites_extra;

typedef struct
{
	unsigned char tics;
	unsigned char lock;
} DoorStruct;
DoorStruct *doordata;

//---------------
//
// gamestate structure
//
//---------------

typedef	struct
{
	short			difficulty;
	//short			mapon;
	long		oldscore,score,nextextra;
	short			lives;
	short			health;
	short			ammo;
	short			keys;
	//weapontype		bestweapon,weapon,chosenweapon;

	short			faceframe;
	short			attackframe,attackcount,weaponframe;

	short			episode,secretcount,treasurecount,killcount,
				secrettotal,treasuretotal,killtotal;
	long		TimeCount;
	long		killx,killy;
	BOOL		victoryflag;		// set during victory animations
} gametype;

gametype gamestate;

short loadedgame;